#version 150

#moj_import <golden_selection/util_functions.glsl>

in vec3 Position;
in vec4 Color;

uniform mat4 ModelViewMat;
uniform mat4 ProjMat;

out vec4 vertexColor;
out vec4 gradientColor;
out vec4 gradientResolution;
out float renderSlotHighlight;
out vec3 pos;

void main() {
    pos = Position;
    renderSlotHighlight = 0;
    int id = gl_VertexID % 4;

    vertexColor = Color;

    // slot highlight
    if( roughlyEquals( Color, vec4(1, 1, 1, 0.50196) ) && Position.z == 0 ) {
        float expandSize = 5;
        float resolution = 26;

        // expand quad size
        if(id == 1 || id == 2) { pos.y += expandSize; } else { pos.y -= expandSize; } // vertical
        if(id == 2 || id == 3) { pos.x += expandSize; } else { pos.x -= expandSize; } // horizontal
        // gradient
        if(id == 1 || id == 2) { gradientColor.r = 1; } else { gradientColor.r = 0; } // vertical
        if(id == 2 || id == 3) { gradientColor.g = 1; } else { gradientColor.g = 0; } // horizontal

        renderSlotHighlight = 2;

        gradientResolution.xy = vec2(resolution);
        
        vertexColor = vec4(0.9882, 0.8314, 0.3961, 0.26);
    }
    // right click highlight
    else if( roughlyEquals( Color, vec4(1, 1, 1, 0.50196) ) && Position.z == 100  ) {
        float expandSize = 5;
        float resolution = 26;

        // expand quad size
        if(id == 1 || id == 2) { pos.y -= expandSize; } else { pos.y += expandSize; } // vertical
        if(id == 2 || id == 3) { pos.x -= expandSize; } else { pos.x += expandSize; } // horizontal
        // gradient
        if(id == 1 || id == 2) { gradientColor.r = 0; } else { gradientColor.r = 1; } // vertical
        if(id == 2 || id == 3) { gradientColor.g = 0; } else { gradientColor.g = 1; } // horizontal

        renderSlotHighlight = 3;

        gradientResolution.xy = vec2(resolution);
        
        vertexColor = vec4(0.9882, 0.8314, 0.3961, 0.26);
    }
    // bundle highlight
    else if( roughlyEquals( Color, vec4(1, 1, 1, 0.50196) )  && Position.z == 400 ) {
        float expandSize = 5;
        float resolution = 26;

        // expand quad size
        if(id == 1 || id == 2) { pos.y += expandSize; } else { pos.y -= expandSize; } // vertical
        if(id == 2 || id == 3) { pos.x += expandSize; } else { pos.x -= expandSize; } // horizontal
        // gradient
        if(id == 1 || id == 2) { gradientColor.r = 1; } else { gradientColor.r = 0; } // vertical
        if(id == 2 || id == 3) { gradientColor.g = 1; } else { gradientColor.g = 0; } // horizontal

        renderSlotHighlight = 3;

        gradientResolution.xy = vec2(resolution);
        
        vertexColor = vec4(0.9882, 0.8314, 0.3961, 0.26);
    }


    // tooltip
    if (ProjMat[3][0] == -1) {
        // tooltip top
        if( roughlyEquals(Color, vec4(0.31373, 0, 1, 0.31373) ) ) {
            vertexColor = vec4(0.98824, 0.83137, 0.39608, 1);
        }
        // tooltip bottom
        else if( roughlyEquals(Color, vec4(0.15686, 0, 0.49804, 0.31373) ) ) {
            vertexColor = vec4(0.72157, 0.38824, 0.10196, 1);
        }
        // tooltip background
        else if( roughlyEquals(Color, vec4(0.06275, 0, 0.06275, 0.94118) ) ) {
            vertexColor = vec4(0.6, 0.3176, 0.0824, 0.6);
        }
    }
    
    gl_Position = ProjMat * ModelViewMat * vec4(pos, 1.0);
}
